#ifndef HEADER_NICK
#define HEADER_NICK

#ifdef DMALLOC
#include <dmalloc.h>
#endif

#include "support.h"
#include "defines.h"

class tglobalnick {
  public:
    char name[NICKNAMELEN+1];
    char *ip;
    char *mask;
    char *ident;
    char *host;
    int o;
    int h;
    int operator==(tglobalnick &nick) {
      return(strcasecmp(name,nick.name)==0);
    }
    int operator>=(tglobalnick &nick) {
      return(strcasecmp(name,nick.name)>=0);
    }
    tglobalnick(char *something) {
      strcpy(name,something);
    }
    tglobalnick() {}
};

class tnick {
  public:
    char name[NICKNAMELEN+1];
    char entry[NICKNAMELEN+2];
    int oped;
    int voiced;
    int time;
    int index;
    tglobalnick *global;
    int operator==(tnick &nick) {
      return(strcasecmp(name,nick.name)==0);
    }
    int operator>=(tnick &nick) {
      int retval;
      if(entry[0]=='@') entry[0]=1;
      if(nick.entry[0]=='@') nick.entry[0]=1;
      if(entry[0]=='+') entry[0]=2;
      if(nick.entry[0]=='+') nick.entry[0]=2;
      retval=(strcasecmp(entry,nick.entry)>=0);
      if(entry[0]==1) entry[0]='@';
      if(nick.entry[0]==1) nick.entry[0]='@';
      if(entry[0]==2) entry[0]='+';
      if(nick.entry[0]==2) nick.entry[0]='+';
      return retval;
    }
    tnick(char *something) {
      strcpy(entry,something);
      if(entry[0]=='@') {
        oped=1;
        voiced=0;
        strcpy(name,entry+1);
      } else if(entry[0]=='+') {
        oped=0;
        voiced=1;
        strcpy(name,entry+1);
      } else {
        oped=0;
        voiced=0;
        strcpy(name,entry);
      }
    }
    tnick() {
    }
};

#endif

